###################################################################################################################################################
# Copyright 2015 Orchid Systems 
# -----------------------------
# Permitted for use with Orchid Systems Modules only.
# The code is supplied on an as is basis for training and demonstration purposes only and is not supported by Orchid Systems.
# If this code is deployed in a live production environment it is the responsibility of the End User to ensure 
# that it is operating as required.
###################################################################################################################################################


#################### Import Modules ###########################################
from accpac import *

import time
import datetime
import subprocess

###############################################################################

# Change the margin variable if you require something other than a 10 percent comparison.
warningMargin = 10

def onOpen():
	if rotoID != "PO0700":
		return 0 # don't do anything since the view is not OE0500 O/E sales order details.

	return Continue


def onBeforeVerify():
	rvspyTrace("onBeforeVerify")
	validateCostMarginToOriginalPO()
	return Continue

def validateCostMarginToOriginalPO():
	# Validate the sales margin based on the following requirement:
	#	(Extended Sales - Extended Cost ) / (Extended Sales) * 100 > 10

	global warningMargin

	ponumber = me.get("PONUMBER")
	ponumber = ponumber.strip()

	if (ponumber == ""):
		return Continue


	v = openView("PO0620", 1)
	v.recordClear()
	v.key(1)
	v.browse("PONUMBER = \"" + ponumber + "\"", 1)
	res = v.fetch()
	if (res == 0):
		rcp_cost = float(me.get("EXTENDED"))
		ord_cost = float(v.get("EXTENDED"))

		# sales margin formula:
		salesMargin = ((ord_cost - rcp_cost) / ord_cost) * 100
		salesMargin = abs(salesMargin)

		if (salesMargin > warningMargin):
			# display warning.
			showMessage("Sales Margin " + "{:,.2f}".format(salesMargin) + "% exceeds the " + str(warningMargin) + "% threshold")


	v.close()
